VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsIStream"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' ----==== Const ====----
Private Const CLSID_Stream As String = ""
Private Const IID_IStream As String = "{0000000C-0000-0000-C000-000000000046}"

' ----==== Enums ====----
Private Enum E_vtbOffsets
    '/*** IUnknown methods ***/
    vtb_QueryInterface
    vtb_AddRef
    vtb_Release
    '/*** ISequentialStream methods ***/
    vtb_Read
    vtb_Write
    '/*** IStream methods ***/
    vtb_Seek
    vtb_SetSize
    vtb_CopyTo
    vtb_Commit
    vtb_Revert
    vtb_LockRegion
    vtb_UnlockRegion
    vtb_Stat
    vtb_Clone
End Enum

' ----==== Ole32 API-Deklarationen ====----
Private Declare Function IIDFromString Lib "ole32" ( _
                         ByVal lpsz As Long, _
                         ByVal lpiid As Long) As Long

' ----==== Variablen ====----
Private m_Interface As InterfaceData

' ----==== IUnknown Func ====----
'
'    /// <summary>
'    /// Retrieves pointers to the supported interfaces on an object.
'    /// </summary>
'   HRESULT QueryInterface(
'       REFIID riid,
'       void   **ppvObject
'       );
Public Function QueryInterface(ByVal riid As String) As Long

    Dim lRet As Long
    Dim triid(3) As Long
    Dim ppvObject As Long

    ' IID -> triid
    If IIDFromString(StrPtr(riid), VarPtr(triid(0))) = S_OK Then

        ' QueryInterface des Interfaces aufrufen
        If x_OleInvoke(vtb_QueryInterface, VarPtr(triid(0)), _
            VarPtr(ppvObject)) = S_OK Then

            lRet = ppvObject

        End If

    End If

    QueryInterface = lRet

End Function

' ----==== ISequentialStream Func ====----
'
'    HRESULT (STDMETHODCALLTYPE *Read)(
'        void *pv,
'        ULONG cb,
'        ULONG *pcbRead);
Public Function Read_Stream(ByRef pv() As Byte, ByVal cb As Long) As Long

    Dim lRet As Long
    Dim cbRead As Long

    If x_OleInvoke(vtb_Read, VarPtr(pv(0)), cb, VarPtr(cbRead)) = S_OK Then

        lRet = cbRead

    End If

    Read_Stream = lRet

End Function

'    HRESULT (STDMETHODCALLTYPE *Write)(
'        const void *pv,
'        ULONG cb,
'        ULONG *pcbWritten);
Public Function Write_Stream(ByRef pv() As Byte, ByVal cb As Long) As Long

    Dim lRet As Long
    Dim cbWritten As Long

    If x_OleInvoke(vtb_Write, VarPtr(pv(0)), cb, VarPtr(cbWritten)) = S_OK Then

        lRet = cbWritten

    End If

    Write_Stream = lRet

End Function

' ----==== IStream Func ====----
'
'    HRESULT (STDMETHODCALLTYPE *Seek)(
'        LARGE_INTEGER dlibMove,
'        DWORD dwOrigin,
'        ULARGE_INTEGER *plibNewPosition);
Public Function Seek_Stream(ByVal dlibMove As Currency, ByVal dwOrigin As _
    STREAM_SEEK) As Currency

    Dim cRet As Currency
    Dim libNewPosition As Currency

    dlibMove = dlibMove / 10000

    If x_OleInvoke(vtb_Seek, dlibMove, dwOrigin, VarPtr(libNewPosition)) = S_OK Then

        cRet = libNewPosition * 10000

    End If

    Seek_Stream = cRet

End Function

'    HRESULT (STDMETHODCALLTYPE *SetSize)(
'        ULARGE_INTEGER libNewSize);
Public Function SetSize(ByVal libNewSize As Currency) As Boolean

    Dim bRet As Boolean

    bRet = False
    libNewSize = libNewSize / 10000

    If x_OleInvoke(vtb_SetSize, libNewSize) = S_OK Then

        bRet = True

    End If

    SetSize = bRet

End Function

'    HRESULT (STDMETHODCALLTYPE *CopyTo)(
'        IStream *pstm,
'        ULARGE_INTEGER cb,
'        ULARGE_INTEGER *pcbRead,
'        ULARGE_INTEGER *pcbWritten);
Public Function CopyTo(ByVal pstm As Long, ByVal cb As Currency, ByRef pcbRead As _
    Currency, ByRef pcbWritten As Currency) As Boolean

    Dim bRet As Boolean

    bRet = False
    cb = cb / 10000

    If x_OleInvoke(vtb_CopyTo, pstm, cb, VarPtr(pcbRead), VarPtr(pcbWritten)) = _
        S_OK Then

        pcbRead = pcbRead * 10000
        pcbWritten = pcbWritten * 10000

        bRet = True

    End If

    CopyTo = bRet

End Function

'    HRESULT (STDMETHODCALLTYPE *Commit)(
'        DWORD grfCommitFlags);
Public Function Commit(Optional ByVal grfCommitFlags As STGC = STGC_DEFAULT) As _
    Boolean

    Dim bRet As Boolean

    bRet = False

    If x_OleInvoke(vtb_Commit, grfCommitFlags) = S_OK Then

        bRet = True

    End If

    Commit = bRet

End Function

'    HRESULT (STDMETHODCALLTYPE *Revert)()
Public Function Revert() As Boolean

    Dim bRet As Boolean

    bRet = False

    If x_OleInvoke(vtb_Revert) = S_OK Then

        bRet = True

    End If

    Revert = bRet

End Function

'    HRESULT (STDMETHODCALLTYPE *LockRegion)(
'        ULARGE_INTEGER libOffset,
'        ULARGE_INTEGER cb,
'        DWORD dwLockType);
Public Function LockRegion(ByVal libOffset As Currency, ByVal cb As Currency, _
    ByVal dwLockType As LOCKTYPE) As Boolean

    Dim bRet As Boolean

    bRet = False
    cb = cb / 10000
    libOffset = libOffset / 10000

    If x_OleInvoke(vtb_LockRegion, libOffset, cb, dwLockType) = S_OK Then

        bRet = True

    End If

    LockRegion = bRet

End Function

'    HRESULT (STDMETHODCALLTYPE *UnlockRegion)(
'        ULARGE_INTEGER libOffset,
'        ULARGE_INTEGER cb,
'        DWORD dwLockType);
Public Function UnlockRegion(ByVal libOffset As Currency, ByVal cb As Currency, _
    ByVal dwLockType As LOCKTYPE) As Boolean

    Dim bRet As Boolean

    bRet = False
    cb = cb / 10000
    libOffset = libOffset / 10000

    If x_OleInvoke(vtb_UnlockRegion, libOffset, cb, dwLockType) = S_OK Then

        bRet = True

    End If

    UnlockRegion = bRet

End Function

'    HRESULT (STDMETHODCALLTYPE *Stat)(
'        STATSTG *pstatstg,
'        DWORD grfStatFlag);
Friend Function Stat(ByRef pstatstg As STATSTG, Optional ByVal grfStatFlag As _
    STATFLAG = STATFLAG_DEFAULT) As Boolean

    Dim bRet As Boolean

    bRet = False

    If x_OleInvoke(vtb_Stat) = S_OK Then

        bRet = True

    End If

    Stat = bRet

End Function

'    HRESULT (STDMETHODCALLTYPE *Clone)(
'        IStream **ppstm);
Public Function Clone() As Long

    Dim pRet As Long
    Dim ppstm As Long

    If x_OleInvoke(vtb_Clone, VarPtr(ppstm)) = S_OK Then

        pRet = ppstm

    End If

    Clone = pRet

End Function

' ----==== Interface Helper Func ====----
'
' Initialisiert das Interface ber einen Interface-Pointer
Public Sub Init(ByVal pInterface As Long)

    If pInterface <> 0& Then

        m_Interface.pObject = ObjPtr(Me)
        m_Interface.boolRaiseErrors = False
        m_Interface.pInterface = pInterface

    End If

End Sub

' Ruft Release des Interfaces auf
Private Sub Class_Terminate()

    Call ReleaseInterface(m_Interface)

End Sub

' Fhrt die Funktion des Interfaces aus
Private Function x_OleInvoke(ByVal vtb As E_vtbOffsets, ParamArray var()) As Variant

    ' ist ein Pointer auf ein Interface vorhanden
    If m_Interface.pInterface <> 0& Then

        ' Funktion ausfhren
        x_OleInvoke = OleInvoke(m_Interface, vtb, var)

    End If

End Function

' wird aus der modInterface bei einem Fehler aufgerufen
Public Sub x_RaiseError(ByVal lngErrCode As Long, ByVal strErrText As String)

    Call Err.Raise(lngErrCode, App.EXEName & "\" & TypeName(Me), strErrText)

End Sub

' Fehler auslsen? Standard = False
Public Property Let RaiseErrors(ByVal Raise As Boolean)

    m_Interface.boolRaiseErrors = Raise

End Property

' liefert den Pointer auf das Interface zurck
Public Property Get IfcPtr() As Long

    IfcPtr = m_Interface.pInterface

End Property


