Attribute VB_Name = "modFlacInfo"
Option Explicit

' ----==== Const ====----
Public Const S_OK As Long = &H0&
Public Const BLOCK_SIZE_MIN As Long = 16        ' FLAC specifies a minimum block size of 16
Public Const BLOCK_SIZE_MAX As Long = 65535     ' FLAC specifies a maximum block size of 65535
Public Const SAMPLE_RATE_MIN As Long = 1        ' Sample rate of 0 is invalid
Public Const SAMPLE_RATE_MAX As Long = 655350   ' The maximum sample rate is limited by the

Private Const GdiPlusVersion As Long = &H1&
Private Const API_TRUE As Long = &H1
Private Const API_FALSE As Long = &H0
Private Const CC_STDCALL As Long = &H4&
Private Const IID_Release As Long = &H8&
Private Const IID_IPicture As String = "{7BF80980-BF32-101A-8BBB-00AA00300CAB}"

' ID3V1 Genre
Private Const sGenre As String = "Blues,Classic Rock,Country,Dance,Disco,Funk,Grunge,Hip-Hop," & _
    "Jazz,Metal,New Age,Oldies,Other,Pop,Rhythm and Blues,Rap,Reggae,Rock,Techno," & _
    "Industrial,Alternative,Ska,Death Metal,Pranks,Soundtrack,Euro-Techno,Ambient," & _
    "Trip-Hop,Vocal,Jazz&Funk,Fusion,Trance,Classical,Instrumental,Acid,House,Game," & _
    "Sound Clip,Gospel,Noise,Alternative Rock,Bass,Soul,Punk,Space,Meditative,Instrumental Pop," & _
    "Instrumental Rock,Ethnic,Gothic,Darkwave,Techno-Industrial,Electronic,Pop-Folk,Eurodance," & _
    "Dream,Southern Rock,Comedy,Cult,Gangsta,Top 40,Christian Rap,Pop/Funk,Jungle,Native US,Cabaret," & _
    "New Wave,Psychedelic,Rave,Showtunes,Trailer,Lo-Fi,Tribal,Acid Punk,Acid Jazz,Polka,Retro,Musical," & _
    "Rock n Roll,Hard Rock,Folk,Folk-Rock,National Folk,Swing,Fast Fusion,Bebop,Latin,Revival,Celtic," & _
    "Bluegrass,Avantgarde,Gothic Rock,Progressive Rock,Psychedelic Rock,Symphonic Rock,Slow Rock,Big Band," & _
    "Chorus,Easy Listening,Acoustic,Humour,Speech,Chanson,Opera,Chamber Music,Sonata,Symphony,Booty Bass," & _
    "Primus,Porn Groove,Satire,Slow Jam,Club,Tango,Samba,Folklore,Ballad,Power Ballad,Rhythmic Soul,Freestyle," & _
    "Duet,Punk Rock,Drum Solo,A cappella,Euro-House,Dance Hall,Goa,Drum & Bass,Club-House,Hardcore Techno," & _
    "Terror,Indie,BritPop,Negerpunk,Polsk Punk,Beat,Christian Gangsta Rap,Heavy Metal,Black Metal,Crossover," & _
    "Contemporary Christian,Christian Rock,Merengue,Salsa,Thrash Metal,Anime,Jpop,Synthpop,Abstract,Art Rock," & _
    "Baroque,Bhangra,Big Beat,Breakbeat,Chillout,Downtempo,Dub,EBM,Eclectic,Electro,Electroclash,Emo," & _
    "Experimental,Garage,Global,IDM,Illbient,Industro-Goth,Jam Band,Krautrock,Leftfield,Lounge,Math Rock," & _
    "New Romantic,Nu-Breakz,Post-Punk,Post-Rock,Psytrance,Shoegaze,Space Rock,Trop Rock,World Music," & _
    "Neoclassical,Audiobook,Audio Theatre,Neue Deutsche Welle,Podcast,Indie-Rock,G-Funk,Dubstep,Garage Rock," & _
    "Psybient,Unknown"

' ----==== Enums ====----
Public Enum CodePage
    CP_UTF8 = 65001     ' UTF8
    CP_UTF16_LE = 1200  ' UTF16 - little endian.
    CP_UTF16_BE = 1201  ' UTF16 - big endian.
End Enum

' fr IStream
Public Enum STGTY
    STGTY_STORAGE = &H1
    STGTY_STREAM = &H2
    STGTY_LOCKBYTES = &H3
    STGTY_PROPERTY = &H4
End Enum

' fr IStream und SHCreateStreamOnFileEx
Public Enum STGM
    STGM_FAILIFTHERE = &H0
    STGM_DIRECT = &H0
    STGM_READ = &H0
    STGM_WRITE = &H1
    STGM_READWRITE = &H2
    STGM_SHARE_EXCLUSIVE = &H10
    STGM_SHARE_DENY_WRITE = &H20
    STGM_SHARE_DENY_READ = &H30
    STGM_SHARE_DENY_NONE = &H40
    STGM_CREATE = &H1000
    STGM_TRANSACTED = &H10000
    STGM_CONVERT = &H20000
    STGM_PRIORITY = &H40000
    STGM_NOSCRATCH = &H100000
    STGM_NOSNAPSHOT = &H200000
    STGM_DIRECT_SWMR = &H400000
    STGM_SIMPLE = &H8000000
    STGM_DELETEONRELEASE = &H4000000
End Enum

' fr IStream
Public Enum STGC
    STGC_DEFAULT = &H0
    STGC_OVERWRITE = &H1
    STGC_ONLYIFCURRENT = &H2
    STGC_DANGEROUSLYCOMMITMERELYTODISKCACHE = &H4
    STGC_CONSOLIDATE = &H8
End Enum

' fr IStream
Public Enum STATFLAG
    STATFLAG_DEFAULT = &H0
    STATFLAG_NONAME = &H1
    STATFLAG_NOOPEN = &H2
End Enum

' fr IStream
Public Enum STREAM_SEEK
    STREAM_SEEK_SET = &H0
    STREAM_SEEK_CUR = &H1
    STREAM_SEEK_END = &H2
End Enum

' fr IStream
Public Enum LOCKTYPE
    LOCK_WRITE = &H1
    LOCK_EXCLUSIVE = &H2
    LOCK_ONLYONCE = &H4
End Enum

' GDI+ Status
Private Enum Status
    OK = 0
    GenericError = 1
    InvalidParameter = 2
    OutOfMemory = 3
    ObjectBusy = 4
    InsufficientBuffer = 5
    NotImplemented = 6
    Win32Error = 7
    WrongState = 8
    Aborted = 9
    FileNotFound = 10
    ValueOverflow = 11
    AccessDenied = 12
    UnknownImageFormat = 13
    FontFamilyNotFound = 14
    FontStyleNotFound = 15
    NotTrueTypeFont = 16
    UnsupportedGdiplusVersion = 17
    GdiplusNotInitialized = 18
    PropertyNotFound = 19
    PropertyNotSupported = 20
    ProfileNotFound = 21
End Enum

' ----==== Types ====----
'
' <Value in Bit>, zB. <32> = 32bit = 4Byte
'
' STREAM
' <32>  "fLaC", the FLAC stream marker in ASCII, meaning byte 0 of the stream
'       is 0x66, followed by 0x4C 0x61 0x43
Public Type FLAC_STREAM
    Stream(0 To 3) As Byte
End Type

' METADATA_BLOCK_HEADER
' <1> Last-metadata-block flag: '1' if this block is the last metadata block
'     before the audio blocks, '0' otherwise.
' <7> BLOCK_TYPE
'       0:  STREAMINFO
'       1:  Padding
'       2:  APPLICATION
'       3:  SEEKTABLE
'       4:  VORBIS_COMMENT
'       5:  CUESHEET
'       6:  Picture
' 7-126  : reserved
' 127    : invalid, to avoid confusion with a frame sync code
' <24> Length (in bytes) of metadata to follow (does not include the size of
'      the METADATA_BLOCK_HEADER)
Public Type FLAC_METADATA_BLOCK_HEADER
    BlockType As Byte
    BlockLength(0 To 2) As Byte
End Type

' METADATA_BLOCK_STREAMINFO
' <16>  The minimum block size (in samples) used in the stream.
' <16>  The maximum block size (in samples) used in the stream. (Minimum
'       blocksize == maximum blocksize) implies a fixed-blocksize stream.
' <24>  The minimum frame size (in bytes) used in the stream. May be 0 to imply
'       the value is not known.
' <24>  The maximum frame size (in bytes) used in the stream. May be 0 to imply
'       the value is not known.
' <20>  Sample rate in Hz. Though 20 bits are available, the maximum sample
'       rate is limited by the structure of frame headers to 655350Hz. Also, a value of
'       0 is invalid.
' <3>   (number of channels)-1. FLAC supports from 1 to 8 channels
' <5>   (bits per sample)-1. FLAC supports from 4 to 32 bits per sample. Currently
'       the reference encoder and decoders only support up to 24 bits per sample.
' <36>  Total samples in stream. 'Samples' means inter-channel sample, i.e. one
'       second of 44.1Khz audio will have 44100 samples regardless of the number of
'       channels. A value of zero here means the number of total samples is unknown.
' <128> MD5 signature of the unencoded audio data. This allows the decoder to
'       determine if an error exists in the audio data even when the error does not
'       result in an invalid bitstream.
' NOTES:
'       FLAC specifies a minimum block size of 16 and a maximum block size of 65535,
'       meaning the bit patterns corresponding to the numbers 0-15 in the minimum
'       blocksize and maximum blocksize fields are invalid.
Public Type FLAC_METADATA_BLOCK_STREAMINFO
    MinBlockSize(0 To 1) As Byte
    MaxBlockSize(0 To 1) As Byte
    MinFrameSize(0 To 2) As Byte
    MaxFrameSize(0 To 2) As Byte
    SrChBpsTotal(0 To 7) As Byte
    MD5signature(0 To 15) As Byte
End Type

' VORBIS_COMMENT_VENDOR
' <32> Length (in bytes) of vendor to follow.
' <n>  read a UTF-8 vector as [length] octets
Public Type FLAC_VORBIS_COMMENT_VENDOR
    VendorLength(0 To 3) As Byte
    VendorString() As Byte
End Type

' VORBIS_COMMENT_TAGS
' <32> Count of Tags to follow.
Public Type FLAC_VORBIS_COMMENT_TAGS
    Count(0 To 3) As Byte
End Type

' VORBIS_COMMENT_VECTOR
' <32> Length (in bytes) of vector to follow.
' <n>  read a UTF-8 vector as [length] octets
Public Type FLAC_VORBIS_COMMENT_VECTOR
    VectorLength(0 To 3) As Byte
    VectorString() As Byte
End Type

' METADATA_BLOCK_PICTURE
' <32>  The picture type according to the ID3v2 APIC frame:
'       0 - Other
'       1 - 32x32 pixels 'file icon' (PNG only)
'       2 - Other file icon
'       3 - Cover (front)
'       4 - Cover (back)
'       5 - Leaflet page
'       6 - Media (e.g. label side of CD)
'       7 - Lead artist/lead performer/soloist
'       8 - Artist/performer
'       9 - Conductor
'       10 - Band/Orchestra
'       11 - Composer
'       12 - Lyricist/text writer
'       13 - Recording Location
'       14 - During recording
'       15 - During performance
'       16 - Movie/video screen capture
'       17 - A bright coloured fish
'       18 - Illustration
'       19 - Band/artist logotype
'       20 - Publisher/Studio logotype
'       Others are reserved and should not be used. There may only be one each of
'       picture type 1 and 2 in a file.
' <32>  The length of the MIME type string in bytes.
' <n*8> The MIME type string, in printable ASCII characters 0x20-0x7e. The MIME
'       type may also be --> to signify that the data part is a URL of the picture
'       instead of the picture data itself.
' <32>  The length of the description string in bytes.
' <n*8> The description of the picture, in UTF-8.
' <32>  The width of the picture in pixels.
' <32>  The height of the picture in pixels.
' <32>  The color depth of the picture in bits-per-pixel.
' <32>  For indexed-color pictures (e.g. GIF), the number of colors used, or 0
'       for non-indexed pictures.
' <32>  The length of the picture data in bytes.
' <n*8> The binary picture data.
Public Type FLAC_METADATA_BLOCK_PICTURE
    PicType(0 To 4) As Byte
    MimeTypeLength(0 To 4) As Byte
    MimeTypeString() As Byte
    DescriptionLength(0 To 4) As Byte
    DescriptionString() As Byte
    PicWidth(0 To 4) As Byte
    PicHeight(0 To 4) As Byte
    ColorDepth(0 To 4) As Byte
    ColorOfUsed(0 To 4) As Byte
    PicDataLength(0 To 4) As Byte
    PicDataBinary() As Byte
End Type

' METADATA_BLOCK_PADDING
' <n> n '0' bits (n must be a multiple of 8)
Public Type FLAC_METADATA_BLOCK_PADDING
    Padding() As Byte
End Type

' METADATA_BLOCK_APPLICATION
' <32> Registered application ID. (Visit the registration page to register an ID with FLAC.)
' <n>  Application data (n must be a multiple of 8)
Public Type FLAC_METADATA_BLOCK_APPLICATION
    AppID(0 To 3) As Byte
    AppData() As Byte
End Type

' SEEKPOINT
' <64>  Sample number of first sample in the target frame, or
'       0xFFFFFFFFFFFFFFFF for a placeholder point.
' <64>  Offset (in bytes) from the first byte of the first frame header to the
'       first byte of the target frame's header.
' <16>  Number of samples in the target frame.
' NOTES:
'       For placeholder points, the second and third field values are undefined.
'       Seek points within a table must be sorted in ascending order by sample number.
'       Seek points within a table must be unique by sample number, with the exception
'       of placeholder points.
'       The previous two notes imply that there may be any number of placeholder
'       points, but they must all occur at the end of the table.
Public Type SEEKPOINT
    SampleNumber(0 To 7) As Byte
    Offset(0 To 7) As Byte
    NumberOfSample(0 To 1) As Byte
End Type

' METADATA_BLOCK_SEEKTABLE
' SEEKPOINT+  One or more seek points.
' NOTE:
'   The number of seek points is implied by the metadata header 'length' field,
'   i.e. equal to length / 18.
Public Type FLAC_METADATA_BLOCK_SEEKTABLE
    tSEEKPOINT() As SEEKPOINT
End Type


' CUESHEET_TRACK_INDEX
' <64>  Offset in samples, relative to the track offset, of the index point.
'       For CD-DA, the offset must be evenly divisible by 588 samples (588 samples =
'       44100 samples/sec * 1/75th of a sec). Note that the offset is from the
'       beginning of the track, not the beginning of the audio data.
' <8>   The index point number. For CD-DA, an index number of 0 corresponds to the
'       track pre-gap. The first index in a track must have a number of 0 or 1, and
'       subsequently, index numbers must increase by 1. Index numbers must be unique
'       within a track.
' <3*8> Reserved. All bits must be set to zero.
Public Type CUESHEET_TRACK_INDEX
    OffsetInSamples(0 To 7) As Byte
    IndexPointNumber As Byte
    Reserved(0 To 2) As Byte
End Type

' CUESHEET_TRACK
' <64>  Track offset in samples, relative to the beginning of the FLAC audio
'       stream. It is the offset to the first index point of the track. (Note how this
'       differs from CD-DA, where the track's offset in the TOC is that of the track's
'       INDEX 01 even if there is an INDEX 00.) For CD-DA, the offset must be evenly
'       divisible by 588 samples (588 samples = 44100 samples/sec * 1/75th of a sec).
' <8>   Track number. A track number of 0 is not allowed to avoid conflicting with
'       the CD-DA spec, which reserves this for the lead-in. For CD-DA the number must
'       be 1-99, or 170 for the lead-out; for non-CD-DA, the track number must for 255
'       for the lead-out. It is not required but encouraged to start with track 1 and
'       increase sequentially. Track numbers must be unique within a CUESHEET.
' <12*8> Track ISRC. This is a 12-digit alphanumeric code; see here and here. A
'       value of 12 ASCII NUL characters may be used to denote absence of an ISRC.
' <1>   The track type: 0 for audio, 1 for non-audio. This corresponds to the CD-DA
'       Q-channel control bit 3.
' <1>   The pre-emphasis flag: 0 for no pre-emphasis, 1 for pre-emphasis. This
'       corresponds to the CD-DA Q-channel control bit 5; see here.
' <6+13*8> Reserved. All bits must be set to zero.
' <8>   The number of track index points. There must be at least one index in every
'       track in a CUESHEET except for the lead-out track, which must have zero. For
'       CD-DA, this number may be no more than 100.
'
' CUESHEET_TRACK_INDEX+ For all tracks except the lead-out track, one or more
'       track index points.
Public Type CUESHEET_TRACK
    TrackOffset(0 To 7) As Byte
    TrackNumber As Byte
    TrackISRC(0 To 11) As Byte
    TrackTypePreEmphasisFlagRes(0 To 13)
    NumberOfTrackIndex As Byte
    tCUESHEET_TRACK_INDEX As CUESHEET_TRACK_INDEX
End Type

' METADATA_BLOCK_CUESHEET
' <128*8> Media catalog number, in ASCII printable characters 0x20-0x7e. In
'       general, the media catalog number may be 0 to 128 bytes long; any unused
'       characters should be right-padded with NUL characters. For CD-DA, this is a
'       thirteen digit number, followed by 115 NUL bytes.
' <64>  The number of lead-in samples. This field has meaning only for CD-DA
'       cuesheets; for other uses it should be 0. For CD-DA, the lead-in is the TRACK
'       00 area where the table of contents is stored; more precisely, it is the number
'       of samples from the first sample of the media to the first sample of the first
'       index point of the first track. According to the Red Book, the lead-in must be
'       silence and CD grabbing software does not usually store it; additionally, the
'       lead-in must be at least two seconds but may be longer. For these reasons the
'       lead-in length is stored here so that the absolute position of the first track
'       can be computed. Note that the lead-in stored here is the number of samples up
'       to the first index point of the first track, not necessarily to INDEX 01 of the
'       first track; even the first track may have INDEX 00 data.
' <1>   1 if the CUESHEET corresponds to a Compact Disc, else 0.
' <7+258*8> Reserved. All bits must be set to zero.
' <8>   The number of tracks. Must be at least 1 (because of the requisite lead-out
'       track). For CD-DA, this number must be no more than 100 (99 regular tracks and
'       one lead-out track).
'
' CUESHEET_TRACK+ One or more tracks. A CUESHEET block is required to have a
'       lead-out track; it is always the last track in the CUESHEET. For CD-DA, the
'       lead-out track number must be 170 as specified by the Red Book, otherwise is
'       must be 255.
Public Type FLAC_METADATA_BLOCK_CUESHEET
    MediaCatalogNumber(0 To 127) As Byte
    NumberOfLeadInSamples(0 To 7) As Byte
    CorrespondsToCDRes(0 To 258) As Byte
    NumberOfTracks As Byte
    tCUESHEET_TRACK As CUESHEET_TRACK
End Type

Public Type ID3V1
    Title(0 To 29) As Byte
    Artist(0 To 29) As Byte
    Album(0 To 29) As Byte
    Year(0 To 3) As Byte
    Comment(0 To 27) As Byte
    Track(0 To 1) As Byte
    Genre As Byte
End Type

Public Type ID3V1HEADER
    Tag(0 To 2) As Byte
    Id3Fields As ID3V1
End Type

Public Type ID3V2HEADER
    Identifier(0 To 2) As Byte
    Version(0 To 1) As Byte
    Flags As Byte
    Size(0 To 3) As Byte
End Type

Public Type ID3V2FRAMEHEADER
    ID(0 To 3) As Byte
    Size(0 To 3) As Byte
    Flags(0 To 1) As Byte
End Type

Public Type GUID
    data1 As Long
    data2 As Integer
    data3 As Integer
    data4(7) As Byte
End Type

' fr IStream
Public Type STATSTG
    atime As Currency
    cbSize As Currency
    CLSID As GUID
    ctime As Currency
    grfLocksSupported As LOCKTYPE
    grfMode As STGM
    grfStateBits As Long
    mtime As Currency
    pwcsName As Long
    Reserved As Long
    Type As STGTY
End Type

' fr GDI+
Private Type GDIPlusStartupInput
    GdiPlusVersion As Long
    DebugEventCallback As Long
    SuppressBackgroundThread As Long
    SuppressExternalCodecs As Long
End Type

' fr GDI+
Private Type GdiplusStartupOutput
    NotificationHook As Long
    NotificationUnhook As Long
End Type

' fr OleCreatePictureIndirect
Private Type PICTDESC
    cbSizeOfStruct As Long
    PicType As Long
    hgdiObj As Long
    hPalOrXYExt As Long
End Type

' ----==== Kernel32 API-Deklarationen ====----
Public Declare Sub CopyMemory Lib "kernel32.dll" _
                   Alias "RtlMoveMemory" ( _
                   ByRef Destination As Any, _
                   ByRef Source As Any, _
                   ByVal Length As Long)

Private Declare Function MultiByteToWideChar Lib "kernel32.dll" ( _
                         ByVal CodePage As Long, _
                         ByVal dwFlags As Long, _
                         ByVal lpMultiByteStr As Long, _
                         ByVal cbMultiByte As Long, _
                         ByVal lpWideCharStr As Long, _
                         ByVal cchWideChar As Long) As Long

' ----==== Shlwapi API-Deklarationen ====----
Public Declare Function SHCreateStreamOnFileEx Lib "Shlwapi.dll" ( _
                        ByVal pszFile As Long, _
                        ByVal grfMode As STGM, _
                        ByVal dwAttributes As Long, _
                        ByVal fCreate As Long, _
                        ByVal pstmTemplate As Long, _
                        ByRef ppstm As Long) As Long
                        
Public Declare Function PathFileExistsW Lib "Shlwapi.dll" ( _
                        ByVal pszFile As Long) As Long
                        
Private Declare Function SHCreateMemStream Lib "Shlwapi.dll" ( _
                         ByVal pInit As Long, _
                         ByVal cbInit As Long) As Long
                        
' ----==== Ole32.dll Deklarationen ====----
Private Declare Function CLSIDFromString Lib "Ole32.dll" ( _
                         ByVal pstring As Long, _
                         ByRef pCLSID As GUID) As Long
                        
' ----==== Oleaut32.dll Deklarationen ====----
Private Declare Function OleCreatePictureIndirect Lib "Oleaut32.dll" ( _
                         ByRef lpPictDesc As PICTDESC, _
                         ByRef riid As GUID, _
                         ByVal fOwn As Boolean, _
                         ByRef lplpvObj As Object) As Long

Private Declare Function DispCallFunc Lib "Oleaut32.dll" ( _
                         ByVal pvInstance As Long, _
                         ByVal oVft As Long, _
                         ByVal cc As Long, _
                         ByVal vtReturn As VbVarType, _
                         ByVal cActuals As Long, _
                         ByVal prgvt As Any, _
                         ByVal prgpvarg As Any, _
                         ByRef pvargResult As Variant) As Long
                        
' ----==== Gdiplus.dll Deklarationen ====----
Private Declare Function GdiplusShutdown Lib "Gdiplus.dll" ( _
                         ByVal token As Long) As Status

Private Declare Function GdiplusStartup Lib "Gdiplus.dll" ( _
                         ByRef token As Long, _
                         ByRef lpInput As GDIPlusStartupInput, _
                         ByRef lpOutput As GdiplusStartupOutput) As Status

Private Declare Function GdipDisposeImage Lib "Gdiplus.dll" ( _
                         ByVal image As Long) As Status

Private Declare Function GdipCreateBitmapFromStream Lib "Gdiplus.dll" ( _
                         ByVal mStream As Long, _
                         ByRef mBitmap As Long) As Status
                         
Private Declare Function GdipCreateHBITMAPFromBitmap Lib "Gdiplus.dll" ( _
                         ByVal Bitmap As Long, _
                         ByRef hbmReturn As Long, _
                         ByVal Background As Long) As Status
                        
' ----==== Variablen ====----
Public m_aGenre() As String
Public m_lGenreUnknown As Long

' ----==== Func ====----
'
Public Sub InitFlacInfo()

    ' Const sGenre splitten
    m_aGenre = Split(sGenre, ",")
    
    ' letzter Wert des Arrays ist fr unbekannte Genres
    m_lGenreUnknown = UBound(m_aGenre)

End Sub

' konvertiert ein ByteArray (UTF8, UTF16) -> String
Public Function ConvertFrom(ByRef Source() As Byte, ByVal eCP As CodePage) As String

    Dim sRet As String
    Dim lSize As Long
    Dim pPointer As Long
    Dim lLength As Long
    Dim sBuffer As String

    lSize = UBound(Source) - LBound(Source) + 1
    pPointer = VarPtr(Source(LBound(Source)))
    lLength = MultiByteToWideChar(eCP, 0, pPointer, lSize, 0, 0)

    If lLength > 0& Then

        sBuffer = Space$(lLength)

        If MultiByteToWideChar(eCP, 0, pPointer, lSize, StrPtr(sBuffer), _
            lLength) > 0& Then

            sRet = sBuffer

        End If
        
    End If

    ConvertFrom = sRet

End Function

' fr ID3V2HEADER.Size
Public Function GetID3V2DataSize(ByRef Value() As Byte) As Long

    GetID3V2DataSize = lshft((Value(0) And &H7F), 21) Or _
                       lshft((Value(1) And &H7F), 14) Or _
                       lshft((Value(2) And &H7F), 7) Or _
                       (Value(3) And &H7F)
        
End Function

' 2 bis 4Byte Big-Endian zu Little-Endian -> Long
Public Function GetSizeLong(ByRef Value() As Byte) As Long

    Dim lValue As Long
    Dim lSize As Long
    Dim lItem As Long
    
    lSize = UBound(Value)

    If lSize > 3 Then lSize = 3

    For lItem = 0 To lSize
    
        lValue = lValue + (Value(lItem) * (256 ^ (lSize - lItem)))
    
    Next

    GetSizeLong = lValue
    
End Function

' 2 bis 8Byte Big-Endian zu Little-Endian -> Double
Public Function GetSizeDouble(ByRef Value() As Byte) As Double

    Dim dValue As Double
    Dim lSize As Long
    Dim lItem As Long
    
    lSize = UBound(Value)

    If lSize > 7 Then lSize = 7

    For lItem = 0 To lSize
    
        dValue = dValue + (Value(lItem) * (256 ^ (lSize - lItem)))
    
    Next

    GetSizeDouble = dValue

End Function

' fr METADATA_BLOCK_STREAMINFO.SrChBpsTotal -> Samplerate
Public Function GetFlacSampleRate(ByRef bData() As Byte) As Long

    GetFlacSampleRate = rshft(((bData(0) * (256 ^ 2)) + _
                               (bData(1) * (256 ^ 1)) + _
                               (bData(2) * (256 ^ 0))), 4)

End Function

' fr METADATA_BLOCK_STREAMINFO.SrChBpsTotal -> Channelcount
Public Function GetFlacChannels(ByRef bData() As Byte) As Long

    GetFlacChannels = rshft(bData(2) And Not &HF0&, 1) + 1

End Function

' fr METADATA_BLOCK_STREAMINFO.SrChBpsTotal -> Bits per sample
Public Function GetFlacBitsPerSample(ByRef bData() As Byte) As Long

    GetFlacBitsPerSample = rshft((((bData(2) And Not &HFE&) * (256 ^ 1)) + _
                                   (bData(3) And Not &HF&)), 4) + 1

End Function

' fr METADATA_BLOCK_STREAMINFO.SrChBpsTotal -> Total sample
Public Function GetFlacTotalSample(ByRef bData() As Byte) As Double

    GetFlacTotalSample = ((bData(3) And Not &HF0&) * (256 ^ 4)) + _
                          (bData(4) * (256 ^ 3)) + _
                          (bData(5) * (256 ^ 2)) + _
                          (bData(6) * (256 ^ 1)) + _
                          (bData(7) * (256 ^ 1))

End Function

' Sekunden (in Double) zu Stunden:Minuten:Sekunden (String)
Public Function Sek2HMS(ByVal dSeks As Double) As String

    Dim h As Long
    Dim m As Long

    h = dSeks \ 3600
    dSeks = dSeks Mod 3600
    m = dSeks \ 60
    dSeks = dSeks Mod 60

    Sek2HMS = Format$(h, "00") & ":" & Format$(m, "00") & ":" & Format$(dSeks, "00")

End Function

' String an vbNullChar abschneiden
Public Function CutNull(ByVal sStr As String) As String

    Dim sRet As String
    Dim lPos As Long

    sStr = Trim$(sStr)
    
    lPos = InStr(1, sStr, vbNullChar)

    If lPos > 0 Then

        sRet = Mid$(sStr, 1, lPos - 1)

    Else

        sRet = sStr

    End If

    CutNull = sRet

End Function

' ByteArray zu String konvertieren
Public Function StrCNC(ByRef sData() As Byte) As String

    StrCNC = CutNull(StrConv(sData, vbUnicode))
    
End Function

' Left-Shift
Public Function lshft(ByVal num As Long, ByVal shifts As Byte) As Long

    lshft = num * (2 ^ shifts)
    
End Function

' Right-Shift
Public Function rshft(ByVal num As Long, ByVal shifts As Byte) As Long

    rshft = num \ (2 ^ shifts)
    
End Function

' liet eine bestimmte Anzahl von Bytes aus einem IStream
Public Sub ReadFromStream(ByVal cIStream As clsIStream, ByVal pData As Long, _
    ByVal lLength As Long)

    Dim bytData() As Byte

    ReDim bytData(lLength - 1)

    Call cIStream.Read_Stream(bytData, lLength)

    Call CopyMemory(ByVal pData, bytData(0), lLength)

End Sub

Public Function GetPicture(ByRef bPicData() As Byte) As StdPicture

    Dim lBitmap As Long
    Dim hBitmap As Long
    Dim lGdipToken As Long
    Dim pIStream As Long
    Dim tPictDesc As PICTDESC
    Dim tGdipStartupInput As GDIPlusStartupInput
    Dim tGdipStartupOutput As GdiplusStartupOutput

    ' ein IStream-Interface vom ByteArray erstellen
    pIStream = SHCreateMemStream(VarPtr(bPicData(0)), UBound(bPicData) + 1)

    ' Ist ein IStream vorhanden
    If pIStream <> 0& Then

        tGdipStartupInput.GdiPlusVersion = GdiPlusVersion

        ' GDI+ starten
        If GdiplusStartup(lGdipToken, tGdipStartupInput, _
            tGdipStartupOutput) = OK Then

            ' GDI+ Bitmap vom IStream erstellen
            If GdipCreateBitmapFromStream(pIStream, lBitmap) = OK Then

                ' GDI32 Handle vom GDI+ Bitmap abrufen
                If GdipCreateHBITMAPFromBitmap(lBitmap, hBitmap, 0&) = OK Then

                    With tPictDesc
                        .cbSizeOfStruct = Len(tPictDesc)
                        .PicType = PictureTypeConstants.vbPicTypeBitmap
                        .hgdiObj = hBitmap
                        .hPalOrXYExt = 0&
                    End With

                    ' Bitmap vom Handle erstellen
                    If OleCreatePictureIndirect(tPictDesc, Str2Guid(IID_IPicture), _
                        API_FALSE, GetPicture) <> S_OK Then

                        Set GetPicture = Nothing

                    End If

                End If

                ' GDI+ Bitmap lschen
                Call GdipDisposeImage(lBitmap)

            End If

            ' GDI+ beenden
            Call GdiplusShutdown(lGdipToken)

        End If

        ' IStream freigeben
        Call Release(pIStream)

    End If

End Function

' Release Interface
Private Sub Release(ByRef pInterface As Long)

    Dim vRet As Variant

    If pInterface <> 0& Then

        If DispCallFunc(pInterface, IID_Release, CC_STDCALL, vbLong, _
            0&, 0&, 0&, vRet) = S_OK Then

            pInterface = 0&

        End If

    End If

End Sub

' konvertiert einen GUID-String zu Type GUID
Private Function Str2Guid(ByVal str As String) As GUID

    Call CLSIDFromString(StrPtr(str), Str2Guid)
    
End Function
